﻿Imports System.Windows.Media

#Region "FileHeader"
#If False Then
Hier gibts einmal die PathDataSamples, auch mit Laden/Speichern, im Gui kann man dann Versuche anstellen mit der Path-Markup-Syntax.
Zum andern eine RoundScala - das ist ein Dingens, was aus Value von 0.0 - 1.0 einen SmartFormatted-String generiert der ein Kreissegment beschreibt (Value=1 -> Vollkreis). Daran binde Xaml einen Path, und schon hat man eine Art runder Progressbar.
#End If '-- Options, Imports
Imports System.ComponentModel
Imports System.Collections.ObjectModel
Imports System.IO
#End Region 'FileHeader

Public Class MainModel : Inherits MainModelBase(Of MainModel)

   Private _DataFile As New FileInfo("..\..\PathData.Data")

   Private __PathDataSamples As New ObservableCollection(Of PathDataSample)()
   Public Property PathDataSamples() As ICollectionView = CollectionViewSource.GetDefaultView(__PathDataSamples)
   Public Property DragablePath As New DragablePath
   Public Property cmdLoad() As New RelayCommand(AddressOf Load)
   Public Property cmdSave() As New RelayCommand(AddressOf Save)

   Public WithEvents Scala As New RoundScala
   Public Property Ellipse As New EllipseVM
   Public Property ArcSegment As New ArcSegmentVM

   Public Sub New()
      If IsProvisional Then
         __PathDataSamples.Add(New PathDataSample With {.Data = "m10,50 l50,50 v-60", .Name = "move Pen", .Description = "move Pen"})
         PathDataSamples.MoveCurrentToFirst()
         Return
      End If
      Load()
   End Sub
   Private Sub Save()
      _DataFile.Serialize(__PathDataSamples)
      System.Media.SystemSounds.Asterisk.Play()
   End Sub

   Private Sub Load()
      Dim x = _DataFile.Deserialize(Of ObservableCollection(Of PathDataSample))()
      __PathDataSamples.ReFillBy(x)
      PathDataSamples.MoveCurrentToFirst()
   End Sub

End Class
