﻿Imports System.Globalization
Imports System.Data

Namespace System.Windows.Controls

   Public Class DelegateConverter : Inherits DependencyObject : Implements IValueConverter

      Public Shared ReadOnly ConversionProperty As DependencyProperty = New DepProp(Nops.Echo(Of Object), GetType(DelegateConverter), "Conversion")
      Public Property Conversion() As Func(Of Object, Object)
         <DebuggerStepThrough()> _
         Get
            Return DirectCast(GetValue(ConversionProperty), Func(Of Object, Object))
         End Get
         <DebuggerStepThrough()> _
         Set(NewValue As Func(Of Object, Object))
            SetValue(ConversionProperty, NewValue)
         End Set
      End Property

      Public Shared ReadOnly BackConversionProperty As DependencyProperty = New DepProp(Nops.Echo(Of Object), GetType(DelegateConverter), "BackConversion")
      Public Property BackConversion() As Func(Of Object, Object)
         <DebuggerStepThrough()> _
         Get
            Return DirectCast(GetValue(BackConversionProperty), Func(Of Object, Object))
         End Get
         <DebuggerStepThrough()> _
         Set(NewValue As Func(Of Object, Object))
            SetValue(BackConversionProperty, NewValue)
         End Set
      End Property

      <DebuggerStepThrough()> _
      Public Overridable Function Convert(value As Object, targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IValueConverter.Convert
         Return Conversion(value)
      End Function

      <DebuggerStepThrough()> _
      Public Function ConvertBack(value As Object, targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IValueConverter.ConvertBack
         Return BackConversion(value)
      End Function
   End Class

End Namespace
