﻿Imports System.Runtime.CompilerServices

Namespace System.Reflection
   Public Module ReflectionX

      <Extension> _
      Public Iterator Function GetResourceAbsoluteUries(asm As Assembly, folder As String) As IEnumerable(Of String)
         Dim asmName = asm.GetName().Name
         Using stream = asm.GetManifestResourceStream(Convert.ToString(asmName) & ".g.resources"),
            reader = New System.Resources.ResourceReader(stream)
            Dim enrt = reader.GetEnumerator()
            While enrt.MoveNext()
               Dim sKey = DirectCast(enrt.Key, String)
               If sKey.StartsWith(folder, StringComparison.OrdinalIgnoreCase) Then
                  Yield String.Format("pack://application:,,,/{0};component/{1}", asmName, sKey)
               End If
            End While
         End Using
      End Function
   End Module
End Namespace

