﻿Imports System.Globalization
Imports System.Data
Imports System.Windows.Markup
Imports System.Reflection

Namespace System.Windows.Controls

   Public Class DelegateConverterExtension : Inherits MarkupExtension : Implements IValueConverter


      Private Conversion As Func(Of Object, Object)
      Public Sub New(Source As Object, path As PropertyPath)
         If ComponentModel.NotifyPropertyChanged.IsInDesignMode Then Return
         Dim _Resolver = New PropertyPathResolver With {.PropertyPath = path.Path}
         Conversion.Be(_Resolver.GetValueFrom(Source))
      End Sub

      <DebuggerStepThrough()> _
      Public Overridable Function Convert(value As Object, targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IValueConverter.Convert
         'Return Color.FromRgb(255, 0, 0)

         'Dim u = _Binding.ProvideValue(Nothing)
         'Dim Conversion = DirectCast(_Binding.ProvideValue(Nothing), Func(Of Object, Object))
         Return Conversion(value)
      End Function

      <DebuggerStepThrough()> _
      Public Function ConvertBack(value As Object, targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IValueConverter.ConvertBack
         'Return BackConversion(value)
         Return value
      End Function

      Public Overrides Function ProvideValue(serviceProvider As IServiceProvider) As Object
         Return Me
      End Function
   End Class

End Namespace
