﻿Imports System.Runtime.InteropServices

Namespace System.Windows.Controls

   Public Class Screen

      Private Delegate Function MonitorEnumProc(hDesktop As IntPtr, hdc As IntPtr, ByRef rct As ApiRect, dwData As Integer) As Boolean

      <StructLayout(LayoutKind.Sequential)> _
      Private Structure ApiRect
         Public left As Integer
         Public top As Integer
         Public right As Integer
         Public bottom As Integer
      End Structure
      <DllImport("user32")> _
      Private Shared Function EnumDisplayMonitors(hdc As IntPtr, lpRect As IntPtr, callback As MonitorEnumProc, dwData As Integer) As Boolean
      End Function

      Public Shared Function GetWorkingAreas() As List(Of Rect)
         Dim result = New List(Of Rect)
         Dim callback As MonitorEnumProc = Function(hDesktop As IntPtr, hdc As IntPtr, ByRef rct As ApiRect, dwData As Integer)
                                              With rct
                                                 result.Add(New Rect(.left, .top, .right - .left, .bottom - .top))
                                              End With
                                              Return True
                                           End Function
         If Not EnumDisplayMonitors(IntPtr.Zero, IntPtr.Zero, callback, 0) Then Throw New Exception("An error occured while enumerating monitors")
         Return result
      End Function

   End Class

End Namespace