﻿Imports System.ComponentModel
Public Class EllipseVM : Inherits NotifyPropertyChanged

   Public Property Size As New Size(200, 100)

   Public Sub New()
      Update()
   End Sub

   Private _X As Double = 100
   Public Property X() As Double
      Get
         Return _X
      End Get
      Set(ByVal value As Double)
         ChangePropIfDifferent(value, _X, AddressOf Update, "X", "Tangent0", "Touch")
      End Set
   End Property


   Private Sub Update()
#If False Then
   EllipsePunkt:  x²/a²+y²/b²=1
   y²/b²=1-x²/a²
   y²=b²(1-x²/a²)

   TangentePunkt:  x*x1/a²+y*y1/b²=1
   y*y1/b²=1-x*x1/a²
   y=(b²/y1)*(1-x*x1/a²)

   x*x1/a²=1-y*y1/b²
   x=(a²/x1)(1-y*y1/b²)
#End If
      Dim a2 = Size.Width * Size.Width
      Dim b2 = Size.Height * Size.Height
      Dim x = _X

      'Ellipse
      Dim x2 = x * x
      Dim y = Math.Sqrt(b2 * (1 - x2 / a2))
      _Touch = New Point(x, y - Size.Height)

      'Tangentenpunkt
      If x.IsInRange(-Size.Width / 2, Size.Width / 2) Then
         'tangente-x festlegen, y errechnen: y=b²/y1*(1-x*x1/a²)
         Dim xt = Size.Width + 30
         Dim yt = (b2 / y) * (1 - xt * x / a2)
         _Tangent0 = New Point(xt, yt - Size.Height)
      Else
         'tangente-y festlegen, x errechnen: x=(a²/x1)(1-y*y1/b²)
         Dim yt = Size.Height + 30
         Dim xt = (a2 / x) * (1 - yt * y / b2)
         _Tangent0 = New Point(xt, yt - Size.Height)
      End If
   End Sub

   Private _Touch As New Point
   Public ReadOnly Property Touch() As Point
      Get
         Return _Touch
      End Get
   End Property

   Private _Tangent0 As Point
   Public ReadOnly Property Tangent0() As Point
      Get
         Return _Tangent0
      End Get
   End Property


End Class
